package com.example.morozovexam;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class listOfTableGames extends AppCompatActivity implements View.OnClickListener {

    Button add, back, clear;
    Spinner sort;
    EditText search;

    private adapterView adapter;
    private List<tableGamesModel> gamesList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_list_of_table_games);

        add = findViewById(R.id.addBTN);
        add.setOnClickListener(this);

        back = findViewById(R.id.backBTN);
        back.setOnClickListener(this);

        clear = findViewById(R.id.clearSortBTN);
        clear.setOnClickListener(this);

        ListView lvApps = findViewById(R.id.tableGamesLV);
        adapter = new adapterView(listOfTableGames.this, gamesList);
        lvApps.setAdapter(adapter);

        search = findViewById(R.id.searchET);


        sort = findViewById(R.id.sortS);
        sort.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                new fillList().execute();
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });

       new fillList().execute();
    }

    @Override
    public void onClick(View v)
    {
        switch(v.getId())
        {
            case R.id.addBTN:
                startActivity(new Intent(this, addNew.class));
                break;
            case R.id.backBTN:
                break;
            case R.id.clearSortBTN:
                break;
        }
    }

    private class fillList extends AsyncTask<Void, Void, String>
    {
        @Override
        protected String doInBackground(Void... voids)
        {
            try {
                URL url = new URL("https://ngknn.ru:5001/NGKNN/МамшеваЮС/Экзамен/api/TableGames/sortByTableGames?typeOfSort=0&nameProduct=");
                HttpURLConnection connection =(HttpURLConnection)url.openConnection();

                BufferedReader reader =new BufferedReader(new InputStreamReader(connection.getInputStream()));

                StringBuffer result = new StringBuffer();
                String line = "";

                while((line = reader.readLine()) != null)
                {
                    result.append(line);
                }
                return result.toString();
            }
            catch (Exception e) {
                return null;
            }
        }

        @Override
        protected void onPostExecute(String s)
        {
            super.onPostExecute(s);
            try
            {
                gamesList.clear();
                JSONArray tempArr = new JSONArray();
                for (int i = 0; i < tempArr.length(); i++)
                {
                    JSONObject game = tempArr.getJSONObject(i);
                    tableGamesModel temp = new tableGamesModel(
                            game.getInt("ID"),
                            game.getString("Title"),
                            game.getInt("Cost"),
                            game.getInt("StockAvailability"),
                            game.getInt("AvailabilityInTheStore"),
                            game.getString("Description"),
                            game.getString("Rewiews"),
                            game.getString("Image")
                    );
                    gamesList.add(temp);
                    adapter.notifyDataSetInvalidated();
                }
            }
            catch (Exception ex)
            {

            }
        }
    }

}